<template>
	<mobile-frame>
		<view class="main">
			<view class="one">
				<tabs :tabs="tabs" @tabsChange="tabsChange">
					<view class="tabsList">
						<scroll-view scroll-y="true" class="scroll-view" @scrolltolower="toPage">
							<view class="list-scroll-view">
								<view class="one_1" v-if="tabs.active=='1'">
									<button size="mini" @tap="toDislog">查询条件</button>
								</view>
								<view class="one_2">
									<view class="list" v-for="(item, index) in list" :key="index" @tap="toView(item)">
										<view class="list_1" v-if="tabs.active=='0'">
											<view class="goodsList">
												<view class="shopname">
													<view class="shop">
														<text class="iconfont icon-shangdian"></text>
														<text>{{item.shop.name}}</text>
													</view>
													<view class="status">
														{{item.zhStatus}}
													</view>
												</view>
												<view class="goodsList_1">
													<view class="market" v-for="(tag,indexs) in item.spec"
														:key="indexss">
														<view class="market_1">
															<image class="image" v-if="tag.file&&tag.file.length>0"
																:src="tag.file&&tag.file.length>0?tag.file[0].url:''"
																mode=""></image>
															<image class="image" v-else
																:src="tag.goods.file&&tag.goods.file.length>0?tag.goods.file[0].url:''"
																mode=""></image>
														</view>
														<view class="market_2">
															<view class="goodsname textOver">
																{{tag.name||tag.goods.name}}
															</view>
															<view class="specs" v-if="tag.is_set!='0'">
																{{tag.name}}
															</view>
															<text v-if="tag.gift&&tag.gift.length>0" class="gift">赠品</text>
															<text v-if="tag.sp_price" class="act">特价</text>
														</view>
														<view class="market_3">
															<view v-if="item.type=='0'" class="price">
																¥{{tag.price||tag.sell_money}}
															</view>
															<view v-else class="price">
																¥{{tag.group_config.money}}
															</view>
															<view class="num">
																×{{tag.buy_num}}
															</view>
														</view>
													</view>
												</view>
											</view>
											<view class="other">
												<text>共{{item.buy_num_total}}件商品</text>
												<text>实付款¥{{item.real_pay}}</text>
											</view>
											<view class="btn">
												<button v-if="item.status=='0'" size="mini"
													@tap.stop="toCancel_order(item)">取消订单</button>
												<button v-if="item.status=='0'" size="mini"
													@tap.stop="toPay(item)">支付</button>
												<button v-if="item.status=='1'&&item.is_afterSale!=true" size="mini"
													@tap.stop="toCancels(item)">取消订单</button>
												<button v-if="item.status=='2'||item.status=='3'||item.status=='2-'"
													size="mini" @tap.stop="toLogi(item)">查看物流</button>
												<button v-if="item.status=='2'&&item.is_afterSale!=true" size="mini"
													@tap.stop="toConfirm(item)">确认收货</button>
												<button
													v-if="item.status=='2'||item.status=='2-'&&item.is_afterSale!=true"
													size="mini" @tap.stop="toReject(item)">拒收</button>
												<button v-if="item.status=='3'" size="mini"
													@tap.stop="toAfter(item)">申请售后</button>
												<button v-if="item.status=='3'" type="default" size="mini"
													@tap.stop="toAppraise(item)">{{item.rate?'追加评价':'立即评价'}}</button>
											</view>
										</view>
										<view class="list_2" v-else>
											<view class="list_2_1">
												<view class="shopname">
													<text class="iconfont icon-shangdian"></text>
													<text>{{item.shop.name}}</text>
												</view>
												<view class="status">
													{{item.zhStatus||'暂无'}}
												</view>
											</view>
											<view class="list_2_2">
												<view class="goods">
													<view class="goods_1">
														<image class="image"
															v-if="item.spec.file&&item.spec.file.length>0"
															:src="item.spec.file&&item.spec.file.length>0?item.spec.file[0].url:''"
															mode=""></image>
														<image class="image" v-else
															:src="item.goods.file&&item.goods.file.length>0?item.goods.file[0].url:''"
															mode=""></image>
													</view>
													<view class="goods_2">
														<view class="goodsname textOver">
															{{item.goods.name}}
														</view>
														<view class="specs">
															{{item.spec.name}}
														</view>
													</view>
													<view class="goods_3">
														<view class="price">
															¥{{item.spec.price||0}}
														</view>
														<view class="num">
															×{{item.num||0}}
														</view>
													</view>
												</view>
											</view>
											<view class="other">
												<text>共{{item.num||0}}件商品</text>
												<text>实付款¥{{item.pay}}</text>
											</view>
											<view class="btn">
												<button v-if="item.status=='0'||item.status=='1'" size="mini"
													@tap.stop="toCancel(item)">取消订单</button>
												<button v-if="item.status=='0'" size="mini" :disabled="disabled"
													@tap.stop="toPay(item,'group_order')">支付</button>
												<button v-if="item.status=='2'||item.status=='3'||item.status=='2-'"
													size="mini" @tap.stop="toLogi(item,'group_order')">查看物流</button>
												<button v-if="item.status=='2'&&item.is_afterSale!=true" size="mini"
													@tap.stop="toConfirm(item,'group_order')">确认收货</button>
												<button
													v-if="item.status=='2'||item.status=='2-'&&item.is_afterSale!=true"
													size="mini" @tap.stop="toReject(item,'group_order')">拒收</button>
												<button v-if="item.status=='3'" size="mini"
													@tap.stop="toAfter(item,'group_order')">申请售后</button>
											</view>
										</view>
									</view>
								</view>
							</view>
						</scroll-view>
					</view>
				</tabs>
			</view>
			<view class="dialog" v-if="dialog.show==true">
				<view class="dialog_1" v-if="dialog.type=='1'">
					<uni-forms ref="form" :modelValue="searchInfo" :rules="rules" label-width="auto">
						<uni-forms-item label="商品名称查询" name="goods">
							<uni-easyinput type="text" v-model="searchInfo.goods" placeholder="请输入商品名称" />
						</uni-forms-item>
						<uni-forms-item label="状态" name="status">
							<picker class="picker" mode="selector" :range="statusList" @change="statusChange"
								range-key="label">
								<view>{{status_name||'请选择状态'}}</view>
							</picker>
						</uni-forms-item>
					</uni-forms>
					<view class="btn">
						<button type="primary" @click="onSubmit" size="mini">确定</button>
						<button type="primary" @click="dialogClose" size="mini">取消</button>
					</view>
				</view>
			</view>
		</view>
	</mobile-frame>
</template>

<script>
	import moment from 'moment';
	import tabs from '../components/tabs/index.vue';
	export default {
		components: {
			tabs
		},
		data() {
			return {
				// 设备平台信息
				system: {},
				user: {},
				searchInfo: {},
				list: [],
				total: 0,
				skip: 0,
				limit: 6,
				page: 0,
				tabs: {
					active: '0',
					menu: [{
							title: '常规订单',
							active: '0'
						},
						{
							title: '团购订单',
							active: '1'
						}
					]
				},
				// 订单状态
				statusList: [],
				// 条件弹出框
				dialog: {
					show: false,
					type: '1'
				},
				// 状态名称
				status_name: '',
				disabled: false
			};
		},
		onShow: async function() {
			const that = this;
			await that.searchOther();
			await that.watchLogin();
		},
		onPullDownRefresh: async function() {
			const that = this;
			that.clearPage();
			await that.search()
			uni.stopPullDownRefresh();
		},
		methods: {
			// 监听用户是否登录
			watchLogin() {
				const that = this;
				uni.getStorage({
					key: 'token',
					success: async function(res) {
						let user = that.$jwt(res.data);
						that.$set(that, `user`, user);
						// 设备平台信息
						let config = that.$config;
						that.$set(that, `system`, config.system);
						that.search()
					},
					fail: function(err) {
						uni.navigateTo({
							url: `/pages/login/index`
						})
					}
				})
			},
			// 查询列表
			async search() {
				const that = this;
				let user = that.user;
				if (user._id) {
					let info = {
						skip: that.skip,
						limit: that.limit,
						customer: user._id
					}
					let res;
					if (that.tabs.active == '1') {
						res = await that.$api(`/groupOrder/userView`, 'GET', {
							...info,
							...that.searchInfo
						}, 'group')
						if (res.errcode == '0') {
							let list = [...that.list, ...res.data];
							for (let val of list) {
								let status = that.statusList.find(i => i.value == val.status)
								if (status) val.zhStatus = status.label;
							}
							that.$set(that, `list`, list);
							that.$set(that, `total`, res.total)
						}
					} else {
						res = await that.$api(`/viewOrder`, 'GET', {
							...info,
							...that.searchInfo
						})
						if (res.errcode == '0') {
							let list = [...that.list, ...res.data];
							for (let val of list) {
								let status = that.statusList.find(i => i.value == val.status)
								if (status) val.zhStatus = status.label;
							}
							that.$set(that, `list`, list);
							that.$set(that, `total`, res.total)
						}
					}
				}
			},
			// 查询条件
			toDislog() {
				const that = this;
				that.$set(that, `searchInfo`, {})
				that.$set(that, `status_name`, '')
				that.$set(that, `dialog`, {
					show: true,
					type: '1'
				})
			},
			// 关闭弹框
			dialogClose() {
				const that = this;
				that.clearPage();
				that.search();
				that.$set(that, `dialog`, {
					show: false,
					type: '1'
				})
			},
			// 查询
			onSubmit() {
				const that = this;
				that.clearPage();
				that.search();
				that.$set(that, `dialog`, {
					show: false,
					type: '1'
				})
			},
			// 状态选择
			statusChange(e) {
				const that = this;
				let data = that.statusList[e.detail.value];
				if (data) {
					that.$set(that.searchInfo, `status`, data.value);
					that.$set(that, `status_name`, data.label);
				}
			},
			// 订单详细信息
			toView(item, type) {
				const that = this;
				that.clearPage();
				if (that.tabs.active == '1') {
					uni.navigateTo({
						url: `/pagesMy/dough/info?id=${item._id}`
					})
				} else {
					uni.navigateTo({
						url: `/pagesMy/order/info?id=${item._id}&status=${item.status}&is_order=${item.is_order}`
					})
				}
			},
			// 取消订单-未支付||取消订单-已支付
			toCancel(e) {
				const that = this;
				uni.showModal({
					title: '提示',
					content: '确定取消订单吗?',
					success: async function(res) {
						if (res.confirm) {
							if (e.status == '0') {
								const arr = await that.$api(`/orderDeal/cancel`, 'POST', {
									order_id: e._id
								}, 'group');
								if (arr.errcode == '0') {
									uni.showToast({
										title: '申请取消订单完成',
										icon: 'none'
									})
									that.clearPage();
									that.search();
								} else {
									uni.showToast({
										title: arr.errmsg,
										icon: 'none'
									})
								}
							} else {
								if (e.is_afterSale != true) {
									let arr = await that.$api(`/groupAfterSale`, 'POST', {
										order: e._id,
										type: '4'
									}, 'group')
									if (arr.errcode == '0') {
										uni.showToast({
											title: '申请取消订单完成',
											icon: 'none'
										})
										that.clearPage();
										that.search();
									} else {
										uni.showToast({
											title: arr.errmsg,
											icon: 'none'
										})
									}
								} else {
									uni.showToast({
										title: `该订单有售后处理中`,
										icon: 'none'
									})
								}
							}
						}
					}
				});
			},
			// 取消订单-已支付
			toCancels(e) {
				const that = this;
				uni.showModal({
					title: '提示',
					content: '确定取消订单吗?',
					success: async function(res) {
						if (res.confirm) {
							let arr = await that.$api(`/afterSale`, 'POST', {
								order_detail: e._id,
								type: '4'
							})
							if (arr.errcode == '0') {
								uni.showToast({
									title: '申请取消订单完成',
									icon: 'none'
								})
								that.clearPage();
								that.search();
							} else {
								uni.showToast({
									title: arr.errmsg,
									icon: 'none'
								})
							}
						}
					}
				});
			},
			// 取消订单-未支付
			toCancel_order(e) {
				const that = this;
				uni.showModal({
					title: '提示',
					content: '确定取消订单吗?',
					success: async function(res) {
						if (res.confirm) {
							const arr = await that.$api(`/order/cancel`, 'POST', {
								order_id: e._id
							});
							if (arr.errcode == '0') {
								uni.showToast({
									title: '申请取消订单完成',
									icon: 'none'
								})
								that.clearPage();
								that.search();
							} else {
								uni.showToast({
									title: arr.errmsg,
									icon: 'none'
								})
							}
						}
					}
				});
			},
			// 支付
			async toPay(e, type) {
				const that = this;
				let system = that.system;
				that.$set(that, `disabled`, true)
				if (system.uniPlatform == "mp-weixin") {
					uni.showLoading({
						title: '加载中'
					})
					// 支付信息
					let p2;
					if (type == 'group_order') p2 = await that.$api('/orderDeal/pay', 'POST', {
						order_id: e._id,
					}, 'group')
					else p2 = await that.$api('/pay/toPayOrder', 'POST', {
						order_id: e,
						type: '0'
					})
					if (p2.errcode == '0' && p2.data.paySign) {
						uni.requestPayment({
							"provider": "wxpay",
							...p2.data,
							success: function(res) {
								that.$set(that, `disabled`, true)
								uni.showToast({
									title: '支付成功',
									icon: 'none'
								})
							},
							fail: function(err) {
								that.$set(that, `disabled`, true)
								uni.showToast({
									title: `支付失败`,
									icon: 'none'
								})
							},
							complete: function() {
								uni.hideLoading();
								that.clearPage();
								that.search()
							}
						})
					} else {
						uni.showToast({
							title: p2.errmsg || '错误信息',
							icon: 'none'
						})
					}
				} else if (res.data.uniPlatform == "app") {
					// app支付
					uni.requestPayment({
						provider: 'alipay',
						orderInfo: 'orderInfo',
						success: function(res) {
							console.log('success:' + JSON.stringify(res));
						},
						fail: function(err) {
							console.log('fail:' + JSON.stringify(err));
						}
					});
				} else {
					uni.showToast({
						title: `平台不支持支付`,
						icon: 'none'
					})
				}
			},
			// 查看物流
			toLogi(e, type) {
				const that = this;
				that.clearPage();
				if (type == 'group_order') {
					uni.navigateTo({
						url: `/pagesMy/logistics/index?id=${e._id}&type=${'groupOrder'}`
					})
				} else {
					uni.navigateTo({
						url: `/pagesMy/logistics/index?id=${e._id}&type=${'order'}`
					})
				}
			},
			// 确认收货
			async toConfirm(e, type) {
				const that = this;
				uni.showModal({
					title: '提示',
					content: '确定确认收货吗?',
					success: async function(res) {
						if (res.confirm) {
							let arr;
							if (type == 'group_order') {
								arr = await that.$api(`/groupOrder/${e._id}`, 'POST', {
									status: '3'
								}, 'group');
							} else {
								arr = await that.$api(`/orderDetail/${e._id}`, 'POST', {
									status: '3'
								});
							}
							if (arr.errcode == '0') {
								uni.showToast({
									title: '确认收货成功',
									icon: 'none'
								})
								that.clearPage();
								that.search();
							} else {
								uni.showToast({
									title: arr.errmsg,
									icon: 'none'
								})
							}
						}
					}
				});
			},
			// 拒收
			async toReject(e, type) {
				const that = this;
				uni.showModal({
					title: '提示',
					content: '确定拒收快递吗?',
					success: async function(res) {
						if (res.confirm) {
							let arr;
							if (type == 'group_order') {
								arr = await that.$api(`/groupAfterSale`, 'POST', {
									order: e._id,
									type: '5'
								}, 'group')
							} else {
								arr = await that.$api(`/afterSale`, 'POST', {
									order_detail: e._id,
									type: '5'
								})
							}
							if (arr.errcode == '0') {
								uni.showToast({
									title: '拒收申请完成',
									icon: 'none'
								})
								that.clearPage();
								that.search();
							} else {
								uni.showToast({
									title: arr.errmsg,
									icon: 'none'
								})
							}
						}
					}
				});
			},
			// 立即评价
			toAppraise(e) {
				const that = this;
				that.clearPage();
				uni.navigateTo({
					url: `/pagesMy/order/appraise?id=${e._id}&status=${'0'}`
				})
			},
			// 申请售后
			toAfter(e, type) {
				const that = this;
				if (e.is_afterSale != true) {
					that.clearPage();
					if (type == 'group_order') {
						uni.navigateTo({
							url: `/pagesMy/order/service?id=${e._id}&status=${'-3'}`
						})
					} else {
						uni.navigateTo({
							url: `/pagesMy/order/service?id=${e._id}&status=${e.status}`
						})
					}
				} else {
					uni.showToast({
						title: `该订单有售后处理中`,
						icon: 'none'
					})
				}
			},
			// 维护单号
			toMaintain(e) {
				uni.navigateTo({
					url: `/pagesMy/order/detail?id=${e._id}&status=${'1'}`
				})
			},
			// 分页
			toPage(e) {
				const that = this;
				let list = that.list;
				let limit = that.limit;
				if (that.total > list.length) {
					uni.showLoading({
						title: '加载中',
						mask: true
					})
					let page = that.page + 1;
					that.$set(that, `page`, page)
					let skip = page * limit;
					that.$set(that, `skip`, skip)
					that.search();
					uni.hideLoading();
				} else {}
			},
			// 选择选项卡
			tabsChange(e) {
				const that = this;
				that.$set(that.tabs, `active`, e.active)
				that.$set(that, `searchInfo`, {})
				that.$set(that, `status_name`, '')
				that.clearPage();
				that.search()
			},
			// 查询其他信息
			async searchOther() {
				const that = this;
				let res;
				// 查询状态
				res = await that.$api(`/dictData`, 'GET', {
					code: 'order_process'
				})
				if (res.errcode == '0') that.$set(that, `statusList`, res.data);
			},
			// 清空列表
			clearPage() {
				const that = this;
				that.$set(that, `list`, [])
				that.$set(that, `skip`, 0)
				that.$set(that, `limit`, 6)
				that.$set(that, `page`, 0)
			}
		}
	}
</script>

<style lang="scss">
	.main {
		display: flex;
		flex-direction: column;
		width: 100vw;
		height: 100vh;

		.one {
			position: relative;
			flex-grow: 1;
			padding: 2vw 0 0 0;

			.tabsList {
				position: relative;
				width: 100vw;
				height: 90vh;

				.one_1 {
					padding: 2vw;
					text-align: center;

					button {
						background-color: var(--fFB1Color);
						color: #ffffff;
					}
				}

				.one_2 {
					.list {
						background-color: #fff;
						border: 1px solid var(--f5Color);
						padding: 2vw;
						margin: 0 2vw 2vw 2vw;
						border-radius: 5px;

						.list_1 {
							.goodsList {
								border-bottom: 1px solid #f1f1f1;

								.shopname {
									display: flex;
									justify-content: space-between;
									margin: 0 0 2vw 0;

									.shop {
										text:last-child {
											padding: 0 0 0 2vw;
										}
									}

									.status {
										text-align: right;
										color: var(--fFB1Color);
										margin: 0 0 1vw 0;
									}
								}

								.goodsList_1 {
									.market {
										display: flex;
										padding: 0 0 2vw 0;

										.market_1 {
											width: 20vw;
											height: 20vw;

											.image {
												width: 100%;
												height: 100%;
												border-radius: 5px;
												border: 1px solid #858585;
											}
										}

										.market_2 {
											width: 55vw;
											padding: 0 0 0 2vw;

											.goodsname {
												font-size: 16px;
												margin: 0 0 1vw 0;
											}

											.specs {
												font-size: 14px;
												color: #858585;
											}

											.gift {
												margin: 0 1vw 0 0;
												font-size: 12px;
												color: #FFA500;
												border: 1px solid #FFA500;
												border-radius: 5px;
												padding: 0 1vw;
											}

											.act {
												font-size: 12px;
												border: 1px solid var(--fFB1Color);
												color: var(--fFB1Color);
												border-radius: 5px;
												padding: 0 1vw;
											}
										}

										.market_3 {
											width: 15vw;
											text-align: right;

											.price {
												color: var(--fFB1Color);
											}
										}
									}
								}
							}

							.other {
								padding: 0 0 2vw 0;
								margin: 2vw 0;
								text-align: right;
								border-bottom: 1px solid #f1f1f1;

								text {
									font-size: 14px;
									padding: 0 0 0 2vw;
								}
							}

							.btn {
								text-align: right;

								button {
									margin: 0 2vw 0 0;
								}
							}
						}

						.list_2 {
							.list_2_1 {
								display: flex;
								justify-content: space-between;
								margin: 0 0 2vw 0;

								.shopname {
									text:last-child {
										padding: 0 0 0 2vw;
									}
								}

								.status {
									color: var(--fFB1Color);
								}
							}

							.list_2_2 {
								border-bottom: 1px solid #f1f1f1;

								.goods {
									display: flex;
									padding: 0 0 2vw 0;

									.goods_1 {
										width: 20vw;
										height: 20vw;

										.image {
											width: 100%;
											height: 100%;
											border-radius: 5px;
										}
									}

									.goods_2 {
										width: 55vw;
										padding: 0 0 0 2vw;

										.goodsname {
											font-size: 16px;
											margin: 0 0 1vw 0;
										}

										.specs {
											font-size: 14px;
											color: #858585;
										}
									}

									.goods_3 {
										width: 15vw;
										text-align: right;

										.price {
											color: var(--fFB1Color);
										}
									}
								}
							}

							.other {
								padding: 0 0 2vw 0;
								margin: 2vw 0;
								text-align: right;
								border-bottom: 1px solid #f1f1f1;

								text {
									font-size: 14px;
									padding: 0 0 0 2vw;
								}
							}

							.btn {
								text-align: right;

								button {
									margin: 0 1vw 0 0;
								}
							}
						}
					}
				}
			}
		}
	}

	.dialog {
		position: fixed;
		width: 96vw;
		height: 100vh;
		background-color: #ffffff;
		z-index: 99999;
		display: flex;
		flex-direction: column;
		padding: 2vw;

		.uni-input {
			border: #f1f1ff 1px solid;
			padding: 2vw 2vw;
			border-radius: 1vw;
		}

		.picker {
			border: 1px solid #3333;
			border-radius: 5px;
			padding: 2vw;
		}

		.btn {
			text-align: center;

			button {
				margin: 0 2vw 2vw 2vw;
				background-color: #23B67A;
				color: #ffffff;
			}

			.name {
				color: var(--f85Color);
				font-size: var(--font14Size);
			}
		}
	}

	.scroll-view {
		position: absolute;
		top: 0;
		left: 0;
		right: 0;
		bottom: 0;

		.list-scroll-view {
			display: flex;
			flex-direction: column;
		}
	}
</style>
